#include "HeightMap.hh"
#include "CaseMap.hh"
#include <iostream>
#include <ostream>
#include <vector>
#include <gdal/gdal.h>
#include "gdal/gdal_priv.h"
#include <gdal/gdal_frmts.h>




CaseMap produce_casemap(HeightMap* heightmap, float height)
{
    int* test = (int *) CPLMalloc(sizeof(int)*heightmap->width*heightmap->height);
    for (int i; i<(heightmap->width-1)*(heightmap->height-1); i++) {
        int y = i/(heightmap->width-1);
        int x = i%(heightmap->width-1);
        *(test + i) = heightmap->get_pixel(x,y+1)*(heightmap->get_pixel(x,y+1)>heightmap->height) + 
        heightmap->get_pixel(x+1,y+1)*(heightmap->get_pixel(x+1,y+1)>heightmap->height)*2 +
        heightmap->get_pixel(x+1,y)*(heightmap->get_pixel(x+1,y)>heightmap->height)*4 +
        heightmap->get_pixel(x,y)*(heightmap->get_pixel(x,y)>heightmap->height)*8;
    }
    
    return CaseMap(heightmap->width-1, heightmap->height-1, test);


}
//(int a, int b, )


int main(int argc, const char* argv[])
{
    const char* filepath = argv[1];
    HeightMap map(filepath); 
    
    std::cout << "x: " << map.width << "    y: " << map.height << "\n";
    std::cout << "max: " << map.max << "    min: " << map.min << "\n";
    
    
    
    std::cout << "\nend🤡\n";
    auto casemap = produce_casemap(&map, 40.0);

    for (int y = 0; y < casemap.height; y++)
    {
        for (int x = 0; x < casemap.width; x++)
        {
            if (casemap.get_case(x, y)) {
                std::cout << casemap.get_case(x, y) << " ";
            }
        }
       // std::cout << "\n";
    }
}